## argon2 0~20160406

=== debian/changelog ===
argon2 (0~20160406-3) unstable; urgency=high

  * debian/rules: explicit target for optimizations
    (Closes: #828779)

 -- Luca Bruno <lucab@debian.org>  Sun, 21 Aug 2016 09:03:33 +0000

argon2 (0~20160406-2) unstable; urgency=medium

  [ Daniel Kahn Gillmor ]
  * fix Vcs-* endpoints
  * add manpage for argon2 (Closes: #820491)
  * bump Standards-Version to 3.9.8 (no changes needed)

  [ Luca Bruno ]
  * argon2: fix section for utils package

 -- Luca Bruno <lucab@debian.org>  Sat, 16 Apr 2016 09:37:28 +0200

argon2 (0~20160406-1) unstable; urgency=medium

  * First upload to unstable

 -- Luca Bruno <lucab@debian.org>  Fri, 08 Apr 2016 23:47:47 +0200

argon2 (0~20160406-0~exp1) experimental; urgency=medium

  * New upstream release
    + drop Makefile patch, applied upstream
    + stable libargon2.so.0 interface, bump symbols
  * Refreshed debian/control
    + update Vcs-* endpoints
    + bump policy version

 -- Luca Bruno <lucab@debian.org>  Thu, 07 Apr 2016 23:40:58 +0200

argon2 (0~20151206-0~exp1) experimental; urgency=medium

  * Initial release (Closes: #810602)
    + library interface not stable yet, targeting experimental

 -- Luca Bruno <lucab@debian.org>  Fri, 08 Jan 2016 22:34:17 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/default.mk

export SOVER=0
export SONAME=libargon2.so.$(SOVER)
export SOPKG=libargon2-$(SOVER)
export OPTTARGET=$(DEB_TARGET_GNU_CPU)

%:
	dh $@

override_dh_install:
	dh_install
	sed -i s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/ debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
	sed -i s/@DEB_VERSION_UPSTREAM@/$(DEB_VERSION_UPSTREAM)/ debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc

override_dh_auto_test:
	-$(MAKE) -j1 test

## argon2 0~20160821

=== Makefile ===
#
# Argon2 source code package
# 
# This work is licensed under a Creative Commons CC0 1.0 License/Waiver.
# 
# You should have received a copy of the CC0 Public Domain Dedication along with
# this software. If not, see <http://creativecommons.org/publicdomain/zero/1.0/>.
#

RUN = argon2
BENCH = bench
GENKAT = genkat

DIST = phc-winner-argon2

SRC = src/argon2.c src/core.c src/blake2/blake2b.c src/thread.c src/encoding.c
SRC_RUN = src/run.c
SRC_BENCH = src/bench.c
SRC_GENKAT = src/genkat.c
OBJ = $(SRC:.c=.o)

CFLAGS += -std=c89 -pthread -O3 -Wall -g -Iinclude -Isrc
CI_CFLAGS := $(CFLAGS) -Werror=declaration-after-statement -D_FORTIFY_SOURCE=2 \
				-Wextra -Wno-type-limits -Werror -coverage -DTEST_LARGE_RAM

OPTTARGET ?= native
OPTTEST := $(shell $(CC) -Iinclude -Isrc -march=$(OPTTARGET) src/opt.c -c \
			-o /dev/null 2>/dev/null; echo $$?)
# Detect compatible platform
ifneq ($(OPTTEST), 0)
$(info Building without optimizations)
	SRC += src/ref.c
else
$(info Building with optimizations for $(OPTTARGET))
	CFLAGS += -march=$(OPTTARGET)
	SRC += src/opt.c
endif

BUILD_PATH := $(shell pwd)
KERNEL_NAME := $(shell uname -s)

LIB_NAME=argon2
ifeq ($(KERNEL_NAME), Linux)
	LIB_EXT := so
	LIB_CFLAGS := -shared -fPIC -fvisibility=hidden -DA2_VISCTL=1
	SO_LDFLAGS := -Wl,-soname,libargon2.so.0
endif
ifeq ($(KERNEL_NAME), $(filter $(KERNEL_NAME),FreeBSD NetBSD OpenBSD))
	LIB_EXT := so
	LIB_CFLAGS := -shared -fPIC
endif
ifeq ($(KERNEL_NAME), Darwin)
	LIB_EXT := dylib
	LIB_CFLAGS := -dynamiclib -install_name @rpath/lib$(LIB_NAME).$(LIB_EXT)
endif
ifeq ($(findstring MINGW, $(KERNEL_NAME)), MINGW)
	LIB_EXT := dll
	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
endif
ifeq ($(findstring MSYS, $(KERNEL_NAME)), MSYS)
	LIB_EXT := dll
	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
endif
ifeq ($(KERNEL_NAME), SunOS)
	CC := gcc
	CFLAGS += -D_REENTRANT
	LIB_EXT := so
	LIB_CFLAGS := -shared -fPIC
endif

ifeq ($(KERNEL_NAME), Linux)
ifeq ($(CC), clang)
	CI_CFLAGS += -fsanitize=address -fsanitize=undefined
endif
endif

LIB_SH := lib$(LIB_NAME).$(LIB_EXT)
LIB_ST := lib$(LIB_NAME).a

.PHONY: clean dist format $(GENKAT)

all: clean $(RUN) libs 
libs: $(LIB_SH) $(LIB_ST)

$(RUN):	        $(SRC) $(SRC_RUN)
		$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@

$(BENCH):       $(SRC) $(SRC_BENCH)
		$(CC) $(CFLAGS) $^ -o $@

$(GENKAT):      $(SRC) $(SRC_GENKAT)
		$(CC) $(CFLAGS) $^ -o $@ -DGENKAT

$(LIB_SH): 	$(SRC)
		$(CC) $(CFLAGS) $(LIB_CFLAGS) $(LDFLAGS) $(SO_LDFLAGS) $^ -o $@

$(LIB_ST): 	$(OBJ)
		ar rcs $@ $^

clean:
		rm -f $(RUN) $(BENCH) $(GENKAT)
		rm -f $(LIB_SH) $(LIB_ST) kat-argon2* 
		rm -f testcase
		rm -rf *.dSYM
		cd src/ && rm -f *.o
		cd src/blake2/ && rm -f *.o
		cd kats/ &&  rm -f kat-* diff* run_* make_*

dist:
		cd ..; \
		tar -c --exclude='.??*' -z -f $(DIST)-`date "+%Y%m%d"`.tgz $(DIST)/*

test:   $(SRC) src/test.c
		$(CC) $(CFLAGS)  -Wextra -Wno-type-limits $^ -o testcase
		@sh kats/test.sh
		./testcase

testci:   $(SRC) src/test.c
		$(CC) $(CI_CFLAGS) $^ -o testcase
		@sh kats/test.sh
		./testcase

.PHONY: test

format:
		clang-format -style="{BasedOnStyle: llvm, IndentWidth: 4}" \
			-i include/*.h src/*.c src/*.h src/blake2/*.c src/blake2/*.h

=== debian/changelog ===
argon2 (0~20160821-1) unstable; urgency=medium

  * New upstream release
    + drop all patches applied upstream

 -- Luca Bruno <lucab@debian.org>  Tue, 30 Aug 2016 15:25:45 +0000

=== debian/control ===
Source: argon2
Priority: optional
Maintainer: Luca Bruno <lucab@debian.org>
Build-Depends: debhelper (>= 9),
               dh-exec (>=0.3)
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/P-H-C/phc-winner-argon2
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/argon2.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/argon2.git

Package: libargon2-0-dev
Section: libdevel
Architecture: any
Depends: libargon2-0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: memory-hard hashing function - development files
 Argon2 is a password-hashing function that can be used to hash passwords
 for credential storage, key derivation, or other applications.
 .
 There are two main versions of Argon2: Argon2i and Argon2d.
 Argon2i is the safest against side-channel attacks, while Argon2d provides
 the highest resistance against GPU cracking attacks.
 .
 Argon2i and Argon2d are parametrized by:
  * A time cost, which defines the amount of computation realized and
    therefore the execution time, given in number of iterations
  * A memory cost, which defines the memory usage, given in kibibytes
  * A parallelism degree, which defines the number of parallel threads
 .
 This package contains headers and libraries for developing program based
 on argon2.

Package: libargon2-0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: memory-hard hashing function - runtime library
 Argon2 is a password-hashing function that can be used to hash passwords
 for credential storage, key derivation, or other applications.
 .
 There are two main versions of Argon2: Argon2i and Argon2d.
 Argon2i is the safest against side-channel attacks, while Argon2d provides
 the highest resistance against GPU cracking attacks.
 .
 Argon2i and Argon2d are parametrized by:
  * A time cost, which defines the amount of computation realized and
    therefore the execution time, given in number of iterations
  * A memory cost, which defines the memory usage, given in kibibytes
  * A parallelism degree, which defines the number of parallel threads
 .
 This package includes the dynamic library against which programs are linked.

Package: argon2
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: memory-hard hashing function - utility
 Argon2 is a password-hashing function that can be used to hash passwords
 for credential storage, key derivation, or other applications.
 .
 There are two main versions of Argon2: Argon2i and Argon2d.
 Argon2i is the safest against side-channel attacks, while Argon2d provides
 the highest resistance against GPU cracking attacks.
 .
 Argon2i and Argon2d are parametrized by:
  * A time cost, which defines the amount of computation realized and
    therefore the execution time, given in number of iterations
  * A memory cost, which defines the memory usage, given in kibibytes
  * A parallelism degree, which defines the number of parallel threads
 .
 This package contains the argon2 tool for hashing data on the command-line.

=== debian/rules ===
--- 
+++ 
@@ -19,8 +19,9 @@
 
 override_dh_install:
 	dh_install
-	sed -i s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/ debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
-	sed -i s/@DEB_VERSION_UPSTREAM@/$(DEB_VERSION_UPSTREAM)/ debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
+	sed -i '/^## /d' debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
+	sed -i s/@HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/ debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
+	sed -i s/@UPSTREAM_VER@/$(DEB_VERSION_UPSTREAM)/ debian/${SOPKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
 
 override_dh_auto_test:
 	-$(MAKE) -j1 test

## argon2 0~20161029

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,18 @@
 #
-# Argon2 source code package
-# 
-# This work is licensed under a Creative Commons CC0 1.0 License/Waiver.
-# 
-# You should have received a copy of the CC0 Public Domain Dedication along with
-# this software. If not, see <http://creativecommons.org/publicdomain/zero/1.0/>.
+# Argon2 reference source code package - reference C implementations
+#
+# Copyright 2015
+# Daniel Dinu, Dmitry Khovratovich, Jean-Philippe Aumasson, and Samuel Neves
+#
+# You may use this work under the terms of a Creative Commons CC0 1.0 
+# License/Waiver or the Apache Public License 2.0, at your option. The terms of
+# these licenses can be found at:
+#
+# - CC0 1.0 Universal : http://creativecommons.org/publicdomain/zero/1.0
+# - Apache 2.0        : http://www.apache.org/licenses/LICENSE-2.0
+#
+# You should have received a copy of both of these licenses along with this
+# software. If not, they may be obtained at the above URLs.
 #
 
 RUN = argon2
@@ -53,6 +61,10 @@
 	LIB_EXT := dylib
 	LIB_CFLAGS := -dynamiclib -install_name @rpath/lib$(LIB_NAME).$(LIB_EXT)
 endif
+ifeq ($(findstring CYGWIN, $(KERNEL_NAME)), CYGWIN)
+	LIB_EXT := dll
+	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
+endif
 ifeq ($(findstring MINGW, $(KERNEL_NAME)), MINGW)
 	LIB_EXT := dll
 	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
@@ -76,11 +88,25 @@
 
 LIB_SH := lib$(LIB_NAME).$(LIB_EXT)
 LIB_ST := lib$(LIB_NAME).a
+LIBRARIES = $(LIB_SH) $(LIB_ST)
+HEADERS = include/argon2.h
 
-.PHONY: clean dist format $(GENKAT)
+INSTALL = install
+
+DESTDIR =
+PREFIX = /usr
+INCLUDE_REL = include
+LIBRARY_REL = lib
+BINARY_REL = bin
+
+INST_INCLUDE = $(DESTDIR)$(PREFIX)/$(INCLUDE_REL)
+INST_LIBRARY = $(DESTDIR)$(PREFIX)/$(LIBRARY_REL)
+INST_BINARY = $(DESTDIR)$(PREFIX)/$(BINARY_REL)
+
+.PHONY: clean dist format $(GENKAT) all install
 
 all: clean $(RUN) libs 
-libs: $(LIB_SH) $(LIB_ST)
+libs: $(LIBRARIES)
 
 $(RUN):	        $(SRC) $(SRC_RUN)
 		$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@
@@ -110,12 +136,12 @@
 		cd ..; \
 		tar -c --exclude='.??*' -z -f $(DIST)-`date "+%Y%m%d"`.tgz $(DIST)/*
 
-test:   $(SRC) src/test.c
+test:           $(SRC) src/test.c
 		$(CC) $(CFLAGS)  -Wextra -Wno-type-limits $^ -o testcase
 		@sh kats/test.sh
 		./testcase
 
-testci:   $(SRC) src/test.c
+testci:         $(SRC) src/test.c
 		$(CC) $(CI_CFLAGS) $^ -o testcase
 		@sh kats/test.sh
 		./testcase
@@ -125,3 +151,11 @@
 format:
 		clang-format -style="{BasedOnStyle: llvm, IndentWidth: 4}" \
 			-i include/*.h src/*.c src/*.h src/blake2/*.c src/blake2/*.h
+
+install: $(RUN) libs
+	$(INSTALL) -d $(INST_INCLUDE)
+	$(INSTALL) $(HEADERS) $(INST_INCLUDE)
+	$(INSTALL) -d $(INST_LIBRARY)
+	$(INSTALL) $(LIBRARIES) $(INST_LIBRARY)
+	$(INSTALL) -d $(INST_BINARY)
+	$(INSTALL) $(RUN) $(INST_BINARY)

=== debian/changelog ===
argon2 (0~20161029-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add libargon2-0-udeb package for debian-installer. Required as
    dependency for libcryptsetup12-udeb. (Closes: #880525)

 -- Jonas Meurer <jonas@freesources.org>  Sat, 06 Jan 2018 17:54:34 +0100

argon2 (0~20161029-1) unstable; urgency=medium

  [ Luca Bruno ]
  * New upstream version 0~20161029

  [ Tyler Hicks ]
  * debian/copyright: argon2 is now dual-licensed
  * debian/libargon2-0.symbols: Add new symbols for argon2id support

 -- Luca Bruno <lucab@debian.org>  Sun, 16 Jul 2017 10:38:31 +0000

=== debian/control ===
--- 
+++ 
@@ -72,3 +72,25 @@
   * A parallelism degree, which defines the number of parallel threads
  .
  This package contains the argon2 tool for hashing data on the command-line.
+
+Package: libargon2-0-udeb
+Section: debian-installer
+Package-Type: udeb
+Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: memory-hard hashing function - runtime library (udeb)
+ Argon2 is a password-hashing function that can be used to hash passwords
+ for credential storage, key derivation, or other applications.
+ .
+ There are two main versions of Argon2: Argon2i and Argon2d.
+ Argon2i is the safest against side-channel attacks, while Argon2d provides
+ the highest resistance against GPU cracking attacks.
+ .
+ Argon2i and Argon2d are parametrized by:
+  * A time cost, which defines the amount of computation realized and
+    therefore the execution time, given in number of iterations
+  * A memory cost, which defines the memory usage, given in kibibytes
+  * A parallelism degree, which defines the number of parallel threads
+ .
+ This udeb package includes the dynamic library for the Debian Installer.

=== debian/rules ===
--- 
+++ 
@@ -25,3 +25,6 @@
 
 override_dh_auto_test:
 	-$(MAKE) -j1 test
+
+override_dh_makeshlibs:
+	dh_makeshlibs -V --add-udeb="libargon2-0-udeb"

## argon2 0~20161029-1.1+8.0trisquel1

=== debian/changelog ===
argon2 (0~20161029-1.1+8.0trisquel1) flidas; urgency=medium

  * Backported from bionic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 08 Oct 2018 20:03:52 +0000

## argon2 0~20171227

=== debian/changelog ===
argon2 (0~20171227-0.3+deb12u1) bookworm; urgency=medium

  * Non-maintainer upload.

  [ Bastian Germann ]
  * Add Breaks on cryptsetup-initramfs (see #1032235)

  [ Guilhem Moulin ]
  * d/gbp.conf: Set 'debian-branch = debian/bookworm'.
  * d/rules: Restore threading support to libargon2-1-udeb (closes: #1034696).
    This is beneficial for cryptsetup-udeb, see #1028250.  Removing threading
    support in libargon2-1-udeb was done for historical reasons no longer
    relevant since Debian Bookworm.  This also restores threading support to
    argon2 which was inadvertently dropped in 0~20171227-0.1 (closes:
    #1032234).

 -- Guilhem Moulin <guilhem@debian.org>  Fri, 21 Apr 2023 21:29:33 +0200

argon2 (0~20171227-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on kfreebsd architectures (Closes: #1004304)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 13 Feb 2022 10:41:34 +0100

argon2 (0~20171227-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix shared library build on hurd-i386 (Closes: #912858)

 -- Samuel Thibault <sthibault@debian.org>  Sun, 13 Jan 2019 14:20:59 +0100

argon2 (0~20171227-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release
  * ABI bump.
  * Build udeb without a dependency on pthreads.

 -- Matthew Garrett <mjg59@google.com>  Wed, 06 Jun 2018 13:08:10 -0700

argon2 (0~20161029-2) unstable; urgency=medium

  * control: move vcs to salsa gitlab
  * control: update to policy version 4.1.4
  * rules: use plain upstream version for pkg-config (Closes: #894885)

 -- Luca Bruno <lucab@debian.org>  Mon, 23 Apr 2018 20:59:38 +0000

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,19 @@
 Maintainer: Luca Bruno <lucab@debian.org>
 Build-Depends: debhelper (>= 9),
                dh-exec (>=0.3)
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Section: libs
 Homepage: https://github.com/P-H-C/phc-winner-argon2
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/argon2.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/argon2.git
+Vcs-Browser: https://salsa.debian.org/debian/argon2
+Vcs-Git: https://salsa.debian.org/debian/argon2.git
 
-Package: libargon2-0-dev
+Package: libargon2-dev
 Section: libdevel
 Architecture: any
-Depends: libargon2-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libargon2-1 (= ${binary:Version}), ${misc:Depends}
+Provides: libargon2-0-dev
+Replaces: libargon2-0-dev
+Conflicts: libargon2-0-dev
 Multi-Arch: same
 Description: memory-hard hashing function - development files
  Argon2 is a password-hashing function that can be used to hash passwords
@@ -32,9 +35,32 @@
  on argon2.
 
 Package: libargon2-0
+Section: libdevel
+Architecture: any
+Depends: libargon2-1 (= ${binary:Version})
+Description: memory-hard hashing function - runtime library
+ Argon2 is a password-hashing function that can be used to hash passwords
+ for credential storage, key derivation, or other applications.
+ .
+ There are two main versions of Argon2: Argon2i and Argon2d.
+ Argon2i is the safest against side-channel attacks, while Argon2d provides
+ the highest resistance against GPU cracking attacks.
+ .
+ Argon2i and Argon2d are parametrized by:
+  * A time cost, which defines the amount of computation realized and
+    therefore the execution time, given in number of iterations
+  * A memory cost, which defines the memory usage, given in kibibytes
+  * A parallelism degree, which defines the number of parallel threads
+ .
+ This package provides compatibility for packages built against older
+ versions of libargon2.
+
+
+Package: libargon2-1
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: cryptsetup-initramfs (<<2:2.6.1-2)
 Multi-Arch: same
 Description: memory-hard hashing function - runtime library
  Argon2 is a password-hashing function that can be used to hash passwords
@@ -73,7 +99,7 @@
  .
  This package contains the argon2 tool for hashing data on the command-line.
 
-Package: libargon2-0-udeb
+Package: libargon2-1-udeb
 Section: debian-installer
 Package-Type: udeb
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/default.mk

export PKG=libargon2
export OPTTARGET=$(DEB_TARGET_GNU_CPU)
export SONAME=$(PKG).so.$(SOVER)
export SOPKG=$(PKG)-$(SOVER)
export SOVER=1
export DEBPREFIX=0~
export UPSTREAMVER=$(subst $(DEBPREFIX),,$(DEB_VERSION_UPSTREAM))

%:
	dh $@

override_dh_install:
	dh_install
	sed -i '/^## /d' debian/${PKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
	sed -i s/@HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/ debian/${PKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc
	sed -i s/@UPSTREAM_VER@/$(UPSTREAMVER)/ debian/${PKG}-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libargon2.pc

override_dh_auto_test:
	-$(MAKE) -j1 test

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb="libargon2-1-udeb"

## argon2 0~20171227-0.3+11.0trisquel0

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Copyright 2015
 # Daniel Dinu, Dmitry Khovratovich, Jean-Philippe Aumasson, and Samuel Neves
 #
-# You may use this work under the terms of a Creative Commons CC0 1.0 
+# You may use this work under the terms of a Creative Commons CC0 1.0
 # License/Waiver or the Apache Public License 2.0, at your option. The terms of
 # these licenses can be found at:
 #
@@ -19,6 +19,9 @@
 BENCH = bench
 GENKAT = genkat
 
+# Increment on an ABI breaking change
+ABI_VERSION = 1
+
 DIST = phc-winner-argon2
 
 SRC = src/argon2.c src/core.c src/blake2/blake2b.c src/thread.c src/encoding.c
@@ -27,7 +30,14 @@
 SRC_GENKAT = src/genkat.c
 OBJ = $(SRC:.c=.o)
 
-CFLAGS += -std=c89 -pthread -O3 -Wall -g -Iinclude -Isrc
+CFLAGS += -std=c89 -O3 -Wall -g -Iinclude -Isrc
+
+ifeq ($(NO_THREADS), 1)
+CFLAGS += -DARGON2_NO_THREADS
+else
+CFLAGS += -pthread
+endif
+
 CI_CFLAGS := $(CFLAGS) -Werror=declaration-after-statement -D_FORTIFY_SOURCE=2 \
 				-Wextra -Wno-type-limits -Werror -coverage -DTEST_LARGE_RAM
 
@@ -48,18 +58,20 @@
 KERNEL_NAME := $(shell uname -s)
 
 LIB_NAME=argon2
-ifeq ($(KERNEL_NAME), Linux)
-	LIB_EXT := so
+ifeq ($(KERNEL_NAME), $(filter $(KERNEL_NAME),Linux GNU GNU/kFreeBSD))
+	LIB_EXT := so.$(ABI_VERSION)
 	LIB_CFLAGS := -shared -fPIC -fvisibility=hidden -DA2_VISCTL=1
-	SO_LDFLAGS := -Wl,-soname,libargon2.so.0
+	SO_LDFLAGS := -Wl,-soname,lib$(LIB_NAME).$(LIB_EXT)
+	LINKED_LIB_EXT := so
 endif
 ifeq ($(KERNEL_NAME), $(filter $(KERNEL_NAME),FreeBSD NetBSD OpenBSD))
 	LIB_EXT := so
 	LIB_CFLAGS := -shared -fPIC
 endif
 ifeq ($(KERNEL_NAME), Darwin)
-	LIB_EXT := dylib
+	LIB_EXT := $(ABI_VERSION).dylib
 	LIB_CFLAGS := -dynamiclib -install_name @rpath/lib$(LIB_NAME).$(LIB_EXT)
+	LINKED_LIB_EXT := dylib
 endif
 ifeq ($(findstring CYGWIN, $(KERNEL_NAME)), CYGWIN)
 	LIB_EXT := dll
@@ -88,6 +100,12 @@
 
 LIB_SH := lib$(LIB_NAME).$(LIB_EXT)
 LIB_ST := lib$(LIB_NAME).a
+
+ifdef LINKED_LIB_EXT
+LINKED_LIB_SH := lib$(LIB_NAME).$(LINKED_LIB_EXT)
+endif
+
+
 LIBRARIES = $(LIB_SH) $(LIB_ST)
 HEADERS = include/argon2.h
 
@@ -105,7 +123,7 @@
 
 .PHONY: clean dist format $(GENKAT) all install
 
-all: clean $(RUN) libs 
+all: $(RUN) libs
 libs: $(LIBRARIES)
 
 $(RUN):	        $(SRC) $(SRC_RUN)
@@ -125,7 +143,7 @@
 
 clean:
 		rm -f $(RUN) $(BENCH) $(GENKAT)
-		rm -f $(LIB_SH) $(LIB_ST) kat-argon2* 
+		rm -f $(LIB_SH) $(LIB_ST) kat-argon2*
 		rm -f testcase
 		rm -rf *.dSYM
 		cd src/ && rm -f *.o
@@ -154,8 +172,16 @@
 
 install: $(RUN) libs
 	$(INSTALL) -d $(INST_INCLUDE)
-	$(INSTALL) $(HEADERS) $(INST_INCLUDE)
+	$(INSTALL) -m 0644 $(HEADERS) $(INST_INCLUDE)
 	$(INSTALL) -d $(INST_LIBRARY)
 	$(INSTALL) $(LIBRARIES) $(INST_LIBRARY)
+ifdef LINKED_LIB_SH
+	cd $(INST_LIBRARY) && ln -s $(notdir $(LIB_SH) $(LINKED_LIB_SH))
+endif
 	$(INSTALL) -d $(INST_BINARY)
 	$(INSTALL) $(RUN) $(INST_BINARY)
+
+uninstall:
+	cd $(INST_INCLUDE) && rm -f $(notdir $(HEADERS))
+	cd $(INST_LIBRARY) && rm -f $(notdir $(LIBRARIES) $(LINKED_LIB_SH))
+	cd $(INST_BINARY) && rm -f $(notdir $(RUN))

=== .pc/kfreebsd/Makefile ===
#
# Argon2 reference source code package - reference C implementations
#
# Copyright 2015
# Daniel Dinu, Dmitry Khovratovich, Jean-Philippe Aumasson, and Samuel Neves
#
# You may use this work under the terms of a Creative Commons CC0 1.0
# License/Waiver or the Apache Public License 2.0, at your option. The terms of
# these licenses can be found at:
#
# - CC0 1.0 Universal : http://creativecommons.org/publicdomain/zero/1.0
# - Apache 2.0        : http://www.apache.org/licenses/LICENSE-2.0
#
# You should have received a copy of both of these licenses along with this
# software. If not, they may be obtained at the above URLs.
#

RUN = argon2
BENCH = bench
GENKAT = genkat

# Increment on an ABI breaking change
ABI_VERSION = 1

DIST = phc-winner-argon2

SRC = src/argon2.c src/core.c src/blake2/blake2b.c src/thread.c src/encoding.c
SRC_RUN = src/run.c
SRC_BENCH = src/bench.c
SRC_GENKAT = src/genkat.c
OBJ = $(SRC:.c=.o)

CFLAGS += -std=c89 -O3 -Wall -g -Iinclude -Isrc

ifeq ($(NO_THREADS), 1)
CFLAGS += -DARGON2_NO_THREADS
else
CFLAGS += -pthread
endif

CI_CFLAGS := $(CFLAGS) -Werror=declaration-after-statement -D_FORTIFY_SOURCE=2 \
				-Wextra -Wno-type-limits -Werror -coverage -DTEST_LARGE_RAM

OPTTARGET ?= native
OPTTEST := $(shell $(CC) -Iinclude -Isrc -march=$(OPTTARGET) src/opt.c -c \
			-o /dev/null 2>/dev/null; echo $$?)
# Detect compatible platform
ifneq ($(OPTTEST), 0)
$(info Building without optimizations)
	SRC += src/ref.c
else
$(info Building with optimizations for $(OPTTARGET))
	CFLAGS += -march=$(OPTTARGET)
	SRC += src/opt.c
endif

BUILD_PATH := $(shell pwd)
KERNEL_NAME := $(shell uname -s)

LIB_NAME=argon2
ifeq ($(KERNEL_NAME), $(filter $(KERNEL_NAME),Linux GNU))
	LIB_EXT := so.$(ABI_VERSION)
	LIB_CFLAGS := -shared -fPIC -fvisibility=hidden -DA2_VISCTL=1
	SO_LDFLAGS := -Wl,-soname,lib$(LIB_NAME).$(LIB_EXT)
	LINKED_LIB_EXT := so
endif
ifeq ($(KERNEL_NAME), $(filter $(KERNEL_NAME),FreeBSD NetBSD OpenBSD))
	LIB_EXT := so
	LIB_CFLAGS := -shared -fPIC
endif
ifeq ($(KERNEL_NAME), Darwin)
	LIB_EXT := $(ABI_VERSION).dylib
	LIB_CFLAGS := -dynamiclib -install_name @rpath/lib$(LIB_NAME).$(LIB_EXT)
	LINKED_LIB_EXT := dylib
endif
ifeq ($(findstring CYGWIN, $(KERNEL_NAME)), CYGWIN)
	LIB_EXT := dll
	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
endif
ifeq ($(findstring MINGW, $(KERNEL_NAME)), MINGW)
	LIB_EXT := dll
	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
endif
ifeq ($(findstring MSYS, $(KERNEL_NAME)), MSYS)
	LIB_EXT := dll
	LIB_CFLAGS := -shared -Wl,--out-implib,lib$(LIB_NAME).$(LIB_EXT).a
endif
ifeq ($(KERNEL_NAME), SunOS)
	CC := gcc
	CFLAGS += -D_REENTRANT
	LIB_EXT := so
	LIB_CFLAGS := -shared -fPIC
endif

ifeq ($(KERNEL_NAME), Linux)
ifeq ($(CC), clang)
	CI_CFLAGS += -fsanitize=address -fsanitize=undefined
endif
endif

LIB_SH := lib$(LIB_NAME).$(LIB_EXT)
LIB_ST := lib$(LIB_NAME).a

ifdef LINKED_LIB_EXT
LINKED_LIB_SH := lib$(LIB_NAME).$(LINKED_LIB_EXT)
endif


LIBRARIES = $(LIB_SH) $(LIB_ST)
HEADERS = include/argon2.h

INSTALL = install

DESTDIR =
PREFIX = /usr
INCLUDE_REL = include
LIBRARY_REL = lib
BINARY_REL = bin

INST_INCLUDE = $(DESTDIR)$(PREFIX)/$(INCLUDE_REL)
INST_LIBRARY = $(DESTDIR)$(PREFIX)/$(LIBRARY_REL)
INST_BINARY = $(DESTDIR)$(PREFIX)/$(BINARY_REL)

.PHONY: clean dist format $(GENKAT) all install

all: $(RUN) libs
libs: $(LIBRARIES)

$(RUN):	        $(SRC) $(SRC_RUN)
		$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@

$(BENCH):       $(SRC) $(SRC_BENCH)
		$(CC) $(CFLAGS) $^ -o $@

$(GENKAT):      $(SRC) $(SRC_GENKAT)
		$(CC) $(CFLAGS) $^ -o $@ -DGENKAT

$(LIB_SH): 	$(SRC)
		$(CC) $(CFLAGS) $(LIB_CFLAGS) $(LDFLAGS) $(SO_LDFLAGS) $^ -o $@

$(LIB_ST): 	$(OBJ)
		ar rcs $@ $^

clean:
		rm -f $(RUN) $(BENCH) $(GENKAT)
		rm -f $(LIB_SH) $(LIB_ST) kat-argon2*
		rm -f testcase
		rm -rf *.dSYM
		cd src/ && rm -f *.o
		cd src/blake2/ && rm -f *.o
		cd kats/ &&  rm -f kat-* diff* run_* make_*

dist:
		cd ..; \
		tar -c --exclude='.??*' -z -f $(DIST)-`date "+%Y%m%d"`.tgz $(DIST)/*

test:           $(SRC) src/test.c
		$(CC) $(CFLAGS)  -Wextra -Wno-type-limits $^ -o testcase
		@sh kats/test.sh
		./testcase

testci:         $(SRC) src/test.c
		$(CC) $(CI_CFLAGS) $^ -o testcase
		@sh kats/test.sh
		./testcase

.PHONY: test

format:
		clang-format -style="{BasedOnStyle: llvm, IndentWidth: 4}" \
			-i include/*.h src/*.c src/*.h src/blake2/*.c src/blake2/*.h

install: $(RUN) libs
	$(INSTALL) -d $(INST_INCLUDE)
	$(INSTALL) -m 0644 $(HEADERS) $(INST_INCLUDE)
	$(INSTALL) -d $(INST_LIBRARY)
	$(INSTALL) $(LIBRARIES) $(INST_LIBRARY)
ifdef LINKED_LIB_SH
	cd $(INST_LIBRARY) && ln -s $(notdir $(LIB_SH) $(LINKED_LIB_SH))
endif
	$(INSTALL) -d $(INST_BINARY)
	$(INSTALL) $(RUN) $(INST_BINARY)

uninstall:
	cd $(INST_INCLUDE) && rm -f $(notdir $(HEADERS))
	cd $(INST_LIBRARY) && rm -f $(notdir $(LIBRARIES) $(LINKED_LIB_SH))
	cd $(INST_BINARY) && rm -f $(notdir $(RUN))

=== debian/changelog ===
argon2 (0~20171227-0.3+11.0trisquel0) aramo; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 09 Nov 2022 13:36:08 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: argon2
 Priority: optional
-Maintainer: Luca Bruno <lucab@debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Build-Depends: debhelper (>= 9),
                dh-exec (>=0.3)
 Standards-Version: 4.1.4
@@ -60,7 +60,6 @@
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Breaks: cryptsetup-initramfs (<<2:2.6.1-2)
 Multi-Arch: same
 Description: memory-hard hashing function - runtime library
  Argon2 is a password-hashing function that can be used to hash passwords

## argon2 0~20190702

=== debian/changelog ===
argon2 (0~20190702-0.1+0~20190710.3+debian8~1.gbp2fb167) unstable; urgency=medium

  ** SNAPSHOT build @2fb16735e211de42d09081a9b7469410b9211572 **

  * UNRELEASED

 -- Ondřej Surý <ondrej@sury.org>  Wed, 10 Jul 2019 11:26:35 +0200

argon2 (0~20190702-0.1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field

  [ Ondřej Surý ]
  * Non-maintainer upload.
  * New upstream version 0~20190702

 -- Ondřej Surý <ondrej@sury.org>  Wed, 10 Jul 2019 10:48:05 +0200

## argon2 0~20190702%2Bdfsg

=== debian/watch ===
version=4
opts=\
filenamemangle=s%(?:.*?/)?v?(\d[\d.]*)\.tar\.gz%argon2-$1.tar.gz%,\
uversionmangle=s/^([\d]{8})/0~$1/,\
dversionmangle=auto,\
repacksuffix=+dfsg \
https://github.com/p-h-c/phc-winner-argon2/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## argon2 0~20190702+dfsg

=== debian/changelog ===
argon2 (0~20190702+dfsg-5) unstable; urgency=medium

  * d/watch: Drop orphaned double quote.
  * d/gbp.conf: Switch debian-branch to debian/unstable.
  * d/control:
    - Update my email address to the d.o one.
    - Drop 'Rules-Requires-Root: no', it's the standard now.
    - Bump Standards-Version to 4.7.2.
  * d/copyright:
    - Bump Debian copyright years to 2025.
    - Update my email address to the d.o one.

 -- Sven Geuer <sge@debian.org>  Sat, 23 Aug 2025 13:15:53 +0200

argon2 (0~20190702+dfsg-4) unstable; urgency=medium

  * New maintainer and add myself as uploader (Closes: #1032462).
    - Update d/control.
  * Switch to DH compat format and raise level
    - Replace Build-Depends debhelper (>= 9) by debhelper-compat (= 13)
      in d/control.
    - Remove file d/compat.
  * d/rules: Disable dh_auto_install as dh_install picks files from where they
    have been built to anyway. Also prevents dh_missing from erroring out what
    happens with debhelper level 13.
  * Introduce autopkgtest per d/tests/*.
    - A secret is hashed via the command line tool and via a python script
      using the library. The results are compared to a pre-defined hash.
  * d/patches/*
    - Provide all patches with DEP-3 compliant headers.
    - Append .patch to all patch file names.
  * Drop the out-dated maintainer provided manual page, upstream's manual page
    has been introduced quite a while ago.
  * d/u/metadata: Add further information about the upstream project.
  * d/watch: Update to version 4.
  * d/libargon2-1.symbols: Add Build-Depends-Package field.
  * d/rules: Enable all hardening options available for ELF binaries.
  * d/copyright: Add missing email addresses, add missing debian/* authors.
  * d/control
    - Update Vcs-Browser and Vcs-Git.
    - Introduce Rules-Requires-Root with value 'no'.
    - Bump Standards-Version to 4.6.2.
  * Introduce d/p/relative-paths.patch to make sure libargon2.pc is generated
    with the correct content.
  * Drop unused file d/libargon2.pc.
  * Make use of the optimized source code available for the x86_64 architecture
    when (cross-)building for this architecture.
  * d/rules: Drop not needed exports and includes, checked by diffoscope.
  * d/s/linitian-overrides: Override lintian's
    override_dh_auto_test-does-not-check-DEB_BUILD_OPTIONS, it is not
    applicable due to Debhelper compat level 13.
  * Introduce d/salsa-ci.yml.

 -- Sven Geuer <debmaint@g-e-u-e-r.de>  Mon, 30 Oct 2023 10:09:28 +0100

argon2 (0~20190702+dfsg-3) unstable; urgency=medium

  * QA upload
  * d/rules: Restore threading support to libargon2-1-udeb (closes: #1034696).
    This is beneficial for cryptsetup-udeb, see #1028250.  Removing threading
    support in libargon2-1-udeb was done for historical reasons no longer
    relevant since Debian Bookworm.

 -- Guilhem Moulin <guilhem@debian.org>  Fri, 21 Apr 2023 19:48:56 +0200

argon2 (0~20190702+dfsg-2) unstable; urgency=medium

  * QA upload
  * Add Breaks on cryptsetup-initramfs (see #1032235)

 -- Bastian Germann <bage@debian.org>  Thu, 16 Mar 2023 00:16:03 +0100

argon2 (0~20190702+dfsg-1) experimental; urgency=medium

  * QA upload
  * Orphan the package (see #1032462)
  * Exclude non-source pdf and Windows build files
  * Pay attention to missing build flags

 -- Bastian Germann <bage@debian.org>  Mon, 13 Mar 2023 12:00:19 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,19 @@
 Source: argon2
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Uploaders: Sven Geuer <sge@debian.org>
+Section: libs
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-Build-Depends: debhelper (>= 9),
-               dh-exec (>=0.3)
-Standards-Version: 4.1.4
-Section: libs
+Build-Depends: debhelper-compat (= 13),
+               dh-exec
+Standards-Version: 4.7.2
 Homepage: https://github.com/P-H-C/phc-winner-argon2
-Vcs-Browser: https://salsa.debian.org/debian/argon2
-Vcs-Git: https://salsa.debian.org/debian/argon2.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/argon2
+Vcs-Git: https://salsa.debian.org/pkg-security-team/argon2.git
 
 Package: libargon2-dev
 Section: libdevel
 Architecture: any
 Depends: libargon2-1 (= ${binary:Version}), ${misc:Depends}
-Provides: libargon2-0-dev
-Replaces: libargon2-0-dev
-Conflicts: libargon2-0-dev
 Multi-Arch: same
 Description: memory-hard hashing function - development files
  Argon2 is a password-hashing function that can be used to hash passwords
@@ -34,32 +32,11 @@
  This package contains headers and libraries for developing program based
  on argon2.
 
-Package: libargon2-0
-Section: libdevel
-Architecture: any
-Depends: libargon2-1 (= ${binary:Version})
-Description: memory-hard hashing function - runtime library
- Argon2 is a password-hashing function that can be used to hash passwords
- for credential storage, key derivation, or other applications.
- .
- There are two main versions of Argon2: Argon2i and Argon2d.
- Argon2i is the safest against side-channel attacks, while Argon2d provides
- the highest resistance against GPU cracking attacks.
- .
- Argon2i and Argon2d are parametrized by:
-  * A time cost, which defines the amount of computation realized and
-    therefore the execution time, given in number of iterations
-  * A memory cost, which defines the memory usage, given in kibibytes
-  * A parallelism degree, which defines the number of parallel threads
- .
- This package provides compatibility for packages built against older
- versions of libargon2.
-
-
 Package: libargon2-1
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: cryptsetup-initramfs (<<2:2.6.1-2)
 Multi-Arch: same
 Description: memory-hard hashing function - runtime library
  Argon2 is a password-hashing function that can be used to hash passwords

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

# Upstream does not honor CPPFLAGS, hence we add it to CFLAGS here.
export CFLAGS+=$(CPPFLAGS)
# Optimized source code is only available for the x86_64 architecture.
export OPTTARGET=$(if $(findstring $(DEB_HOST_GNU_CPU),x86_64),x86-64,none)
export PKG=libargon2
export SONAME=$(PKG).so.$(SOVER)
export SOPKG=$(PKG)-$(SOVER)
export SOVER=1
export DEBPREFIX=0~
export DEBSUFFIX=+dfsg
export ARGON2_VERSION=$(subst $(DEBSUFFIX),,$(subst $(DEBPREFIX),,$(DEB_VERSION_UPSTREAM)))

%:
	dh $@

override_dh_auto_test:
	-$(MAKE) -j1 test

override_dh_auto_install:

override_dh_makeshlibs:
	dh_makeshlibs -V --add-udeb="libargon2-1-udeb"

=== debian/tests/control ===
Tests: hash-a-secret-and-check-the-result
Depends: python3-argon2,
         @
Restrictions: isolation-container
